package com.steerinfo.baseinfo.meterbasecalibranumrel.controller;

import com.steerinfo.baseinfo.meterbasecalibrarelation.model.MeterBaseCalibraRelation;
import com.steerinfo.baseinfo.meterbasecalibrationnum.model.MeterBaseCalibrationNum;
import com.steerinfo.baseinfo.meterbasecalibrationtime.model.MeterBaseCalibrationTime;
import com.steerinfo.baseinfo.meterbasespotinfo.model.MeterBaseSpotInfo;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasecalibranumrel.model.MeterBaseCalibraNumRel;
import com.steerinfo.baseinfo.meterbasecalibranumrel.service.IMeterBaseCalibraNumRelService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.util.StringUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.interceptor.TransactionAspectSupport;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;

/**
 * MeterBaseCalibraNumRel RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-06-28 03:17
 * 类描述
 * 修订历史：
 * 日期：2020-06-28
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCalibraNumRel RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecalibranumrels")
public class MeterBaseCalibraNumRelController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCalibraNumRelService meterBaseCalibraNumRelService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibranumrel:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCalibraNumRel> list = meterBaseCalibraNumRelService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecalibranumrel:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCalibraNumRel> list = meterBaseCalibraNumRelService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCalibraNumRel对象创建")
    @ApiImplicitParam(name = "meterBaseCalibraNumRel", value = "详细实体meterBaseCalibraNumRel", required = true, dataType = "MeterBaseCalibraNumRel")
    //@RequiresPermissions("meterbasecalibranumrel:create")
    @Transactional
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody List<MeterBaseCalibraNumRel> models) {
        try {
            String msg = meterBaseCalibraNumRelService.checkandadd(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecalibranumrel:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCalibraNumRel meterBaseCalibraNumRel = meterBaseCalibraNumRelService.getById(id);
            return success(meterBaseCalibraNumRel);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCalibraNumRel信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCalibraNumRel", value = "详细实体meterBaseCalibraNumRel", required = true, dataType = "MeterBaseCalibraNumRel")
    })
    //@RequiresPermissions("meterbasecalibranumrel:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCalibraNumRel model) {
        try {
            model.setId(id);
            MeterBaseCalibraNumRel meterBaseCalibraNumRel = meterBaseCalibraNumRelService.modify(model);
            return success(meterBaseCalibraNumRel);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的实体集来指定删除对象")
    @ApiImplicitParam(name = "MeterBaseCalibraNumRel", value = "详细实体MeterBaseCalibraNumRel", required = true, dataType = "MeterBaseCalibraNumRel")
    @PutMapping(value = "/")
    public RESTfulResult delete(@RequestBody List<MeterBaseCalibraNumRel> models) {
        try {
            List<String> list = new ArrayList<String>();
            for (MeterBaseCalibraNumRel model : models) {
                String id = model.getRelationNo();
                list.add(id);
            }
            List<String> ids = ListUtils.convertList(list);
            meterBaseCalibraNumRelService.delete(ids);
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "新增计量点校称重量", notes = "根据MeterBaseCalibrationNum,MeterBaseSpotInfo对象创建")
    @Transactional
    @PostMapping(value = "/addSpotNum")
    public RESTfulResult addSpotNum(@RequestBody MeterBaseCalibrationNum mbCalibrationNum, @RequestParam(required = true) String baseSpotNo, @RequestParam(required = true) String baseSpotName) {
        try {
            MeterBaseSpotInfo mbSpotInfo = new MeterBaseSpotInfo();
            mbSpotInfo.setBaseSpotNo(baseSpotNo);
            mbSpotInfo.setBaseSpotName(baseSpotName);
            String msg = meterBaseCalibraNumRelService.addSpotNum(mbCalibrationNum,mbSpotInfo);
            if (msg != null && !msg.equals("")) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认:"+ e.getMessage());
        }
        return success();
    }

    @ApiOperation(value = "废除标识符", notes = "根据传过来的MeterBaseCalibraNumRel集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCalibraNumRel", value = "详细实体MeterBaseCalibraNumRel", required = true, dataType = "MeterBaseCalibraNumRel")
    })
    //@RequiresPermissions("combaseinfo:update")
    @Transactional
    @PostMapping(value = "/abolish")
    public RESTfulResult abolish(@RequestBody List<MeterBaseCalibraNumRel> models) {
        try {
            String msg = meterBaseCalibraNumRelService.abolish(models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

    @ApiOperation(value = "按校称重量编号修改计量点校称重量", notes = "根据传过来的MeterBaseCalibrationNum集合信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "MeterBaseCalibrationNum", value = "详细实体MeterBaseCalibrationNum", required = true, dataType = "MeterBaseCalibrationNum")
    })
    @Transactional
    @PostMapping(value = "/updateBymbCalibWeightNo")
    public RESTfulResult updateBymbCalibWeightNo(@RequestParam(required = true) String calWeightNo,@RequestBody MeterBaseCalibrationNum models) {
        try {
            String msg = meterBaseCalibraNumRelService.updateBymbCalibWeightNo(calWeightNo,models);
            if (StringUtils.isNotEmpty(msg)) {
                return failed(null, msg);
            }
        } catch (Exception e) {
            e.printStackTrace();
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return failed(null, "操作异常，请确认！");
        }
        return success();
    }

}
